#include <QtGui/QHBoxLayout>
#include <QtGui/QVBoxLayout>
#include <QtGui/QScrollArea>
#include <QtGui/QFileDialog>
#include <QtGui/QInputDialog>
#include <QtCore/QSize>
#include <QtCore/QString>
#include "gui.h"

Gui::Gui(QWidget *parent) : QWidget(parent) {

  data = new Data(this);
  QVBoxLayout *guiLayout = new QVBoxLayout;
  setLayout(guiLayout);
  QScrollArea *scroll = new QScrollArea;
  view = new View(data, this);
  view->updateSize();
  scroll->setWidget(view);
  guiLayout->addWidget(scroll);
  data->initChunkList();
  time.start();
  data->calcMandelBrot();
  QObject::connect(data, SIGNAL(mandelReady()), this, SLOT(calcFinished()));
  label = new QLabel;
  guiLayout->addWidget(label);
  QObject::connect(data, SIGNAL(mandelStatus(int)), this, SLOT(updateStatus(int)));
}

void Gui::saveImage() {

  data->saveImage(QFileDialog::getSaveFileName());
}

void Gui::scaleImage() {
  
  bool ok;

  data->scaleImage(QInputDialog::getDouble(this, "Bild skalieren", "Skalierungsfaktor:", 0.25, 0.001, 10, 3, &ok));
  view->updateSize();
}

void Gui::updateStatus(int value) {

 label->setText(QString::fromUtf8("Status: Berechnung läuft") + "     [" + QString::number(value) +"%]");
}

void Gui::calcFinished() {

  view->repaint();
  label->setText("Rechenzeit: " + QString::number(time.elapsed()) + " ms");
}
