#include <QtGui/QVBoxLayout>
#include <QtGui/QPushButton>
#include <QtCore/QString>
#include "gui.h"

Gui::Gui(QWidget *parent) : QWidget(parent) {

  int i;

  QVBoxLayout *guiLayout = new QVBoxLayout;
  setLayout(guiLayout);
  thread = new Thread;
  QObject::connect(thread, SIGNAL(finished()), this, SLOT(threadFinished()));
  for (i = 0; i < 2; i++) {
    countLabel[i] = new QLabel;
    guiLayout->addWidget(countLabel[i]);
  }  
  label = new QLabel;
  guiLayout->addWidget(label);
  QPushButton *startButton = new QPushButton("Start");
  guiLayout->addWidget(startButton);
  QObject::connect(startButton, SIGNAL(clicked()), this, SLOT(startThread()));
  QPushButton *stopButton = new QPushButton("Stop");
  guiLayout->addWidget(stopButton);
  QObject::connect(stopButton, SIGNAL(clicked()), thread, SLOT(quit()));
  object = new Object;
  QObject::connect(object, SIGNAL(counterUpdated(long)), this, SLOT(updateLabel(long)));
  QObject::connect(thread, SIGNAL(counterUpdated(long)), this, SLOT(updateLabel(long)));
  object->moveToThread(thread);
  object->timer->start(1000);
  thread->timer->start(1000);
}

void Gui::startThread() {

  if (!thread->isRunning()) {
    label->setText(QString::fromUtf8("Starte Thread..."));
    thread->start();
  } else {
    label->setText(QString::fromUtf8("Thread läuft noch..."));
  } 
}

void Gui::threadFinished() {

  label->setText("Thread beendet.");
}

void Gui::updateLabel(long value) {

  if (sender() == thread) {
    countLabel[0]->setText(QString::fromUtf8("Thread Counter: ") + QString::number(value));
  } else {
    countLabel[1]->setText(QString::fromUtf8("Object Counter: ") + QString::number(value));  
  }  
}
