/* QParallelObjects demonstriert die Nutzung von QThread als zusätzliche
   Event Loop für Objekte. Je ein QTimer generiert Events sowohl in der 
   Event Loop der Applikation als auch in der Event Loop des Threads.
   Sobald der Thread per Button gestartet ist, werden die Thread-Events
   abgearbeitet. Man erkennt, dass diese in einer Queue landen, wenn der
   Thread nicht läuft. 
*/   

#include <QtGui/QApplication>
#include <QtGui/QMainWindow>
#include <QtGui/QMenuBar>   
#include <QtGui/QMenu>   
#include "gui.h"

int main(int argc, char *argv[])  
{
  QApplication myApp(argc, argv);
  QMainWindow top;
  top.setWindowTitle("QParallelObjects    (c)2012 by Matthias Nagorni");
  Gui *gui = new Gui(&top);
  QMenu *fileMenu = top.menuBar()->addMenu("&Datei");
  fileMenu->addAction("&Beenden", &myApp, SLOT(quit()));
  top.setCentralWidget(gui); 
  top.show();
  return myApp.exec(); 
}
