#include <QtGui/QVBoxLayout>
#include <QtGui/QPushButton>
#include <QtCore/QString>
#include <QtCore>
#include "gui.h"

Gui::Gui(QWidget *parent) : QWidget(parent) {

  primzahlWatcher = 0;
  QVBoxLayout *guiLayout = new QVBoxLayout;
  setLayout(guiLayout);
  label = new QLabel("Berechne kleinste Primzahl > 1e9");
  guiLayout->addWidget(label);
  QPushButton *button = new QPushButton("Start");
  guiLayout->addWidget(button);
  QObject::connect(button, SIGNAL(clicked()), this, SLOT(runCalc()));
}

Gui::~Gui() {

  if (primzahlWatcher) delete primzahlWatcher;
}

long long calc(long long start) {

  long long primzahl, l1;
  
  l1 = start;
  do {
    primzahl = l1;
    for (long long l2 = 2; l2 < l1>>1; l2++) 
      if (!(l1 % l2)) {
        primzahl = 0;
        l1++;
        break;
      }
  } while (!primzahl);
  return(primzahl);
}

void Gui::runCalc() {

  primzahlWatcher = new QFutureWatcher<long long>;
  QObject::connect(primzahlWatcher, SIGNAL(finished()), this, SLOT(primzahlReady()));
  primzahlFuture = QtConcurrent::run(calc, 1e9);
  primzahlWatcher->setFuture(primzahlFuture);
}

void Gui::primzahlReady() {
 
  label->setText("Kleinste Primzahl > 1e9 = " + QString::number(primzahlFuture.result()));
}
