#include <QtGui/QVBoxLayout>
#include <QtGui/QPushButton>
#include <QtCore/QString>
#include <QtCore/QThreadPool>
#include "gui.h"

Gui::Gui(QWidget *parent) : QWidget(parent) {

  int i;

  runnable_id = 0;
  QVBoxLayout *guiLayout = new QVBoxLayout;
  setLayout(guiLayout);
  for (i = 0; i < MAX_RUNNABLE; i++) {
    countLabel[i] = new QLabel;
    guiLayout->addWidget(countLabel[i]);
  }  
  label = new QLabel;
  guiLayout->addWidget(label);
  QPushButton *startButton = new QPushButton("Start");
  guiLayout->addWidget(startButton);
  QObject::connect(startButton, SIGNAL(clicked()), this, SLOT(startRunnable()));
}

Gui::~Gui() {

  for (int i = 0; i < runnable_id; i++) {
    runnable[i]->stop();
  }  
}

void Gui::startRunnable() {

  if (runnable_id < MAX_RUNNABLE) {
    runnable[runnable_id] = new Runnable(runnable_id);
    QObject::connect(runnable[runnable_id], SIGNAL(counterUpdated(int, long)), this, SLOT(updateLabel(int, long)));
    if (QThreadPool::globalInstance()->tryStart(runnable[runnable_id])) {
      label->setText(QString::fromUtf8("Starte Thread..."));
    } else {
      label->setText(QString::fromUtf8("ThreadPool busy..."));
      QThreadPool::globalInstance()->start(runnable[runnable_id]);
    } 
    runnable_id++;
  } else {
    label->setText(QString::fromUtf8("MAX_RUNNABLE erreicht..."));
    QThreadPool::globalInstance()->waitForDone();
    runnable_id = 0;
  }  
}

void Gui::updateLabel(int id, long value) {

  countLabel[id]->setText(QString::fromUtf8("Runnable Counter: ") + QString::number(value));
}
